=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2012-05-17 08:34:51 +0000
+++ CMakeLists.txt	2012-05-21 09:36:37 +0000
@@ -170,9 +170,7 @@
 add_subdirectory (po)
 add_subdirectory (metadata)
 add_subdirectory (src)
-# compizconfig's CMake files confuse the compiz project quite a lot and
-# cause multiple build failures. Don't include it till it's fixed.
-#add_subdirectory (compizconfig)
+add_subdirectory (compizconfig)
 add_subdirectory (xslt)
 add_subdirectory (plugins)
 add_subdirectory (tests)

=== modified file 'compizconfig/CMakeLists.txt'
--- compizconfig/CMakeLists.txt	2012-05-17 06:54:45 +0000
+++ compizconfig/CMakeLists.txt	2012-05-21 09:36:37 +0000
@@ -1,7 +1,3 @@
-set (COMPIZ_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
-set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${COMPIZ_CMAKE_MODULE_PATH})
-include (CompizDefaults)
-
 set (_COMPIZCONFIG_INTERNAL ON)
 set (LIBCOMPIZCONFIG_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/libcompizconfig/cmake )
 set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LIBCOMPIZCONFIG_CMAKE_MODULE_PATH})
@@ -9,10 +5,10 @@
 set (COMPIZCONFIG_LIBRARY_DIRS ${CMAKE_CURRENT_BINARY_DIR}/libcompizconfig)
 
 add_subdirectory (libcompizconfig)
-add_subdirectory (compizconfig-python)
-add_subdirectory (ccsm)
-add_subdirectory (gconf)
-add_subdirectory (gsettings)
+#add_subdirectory (compizconfig-python)
+#add_subdirectory (ccsm)
+#add_subdirectory (gconf)
+#add_subdirectory (gsettings)
 
 add_custom_target (pyclean)
 

=== modified file 'compizconfig/libcompizconfig/CMakeLists.txt'
--- compizconfig/libcompizconfig/CMakeLists.txt	2012-05-17 06:54:45 +0000
+++ compizconfig/libcompizconfig/CMakeLists.txt	2012-05-21 09:36:37 +0000
@@ -3,18 +3,15 @@
 set (COMPIZ_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
 set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${COMPIZ_CMAKE_MODULE_PATH})
 include (CompizDefaults)
-
-find_package (Compiz REQUIRED)
-
-set (CMAKE_MODULE_PATH_ORIG ${CMAKE_MODULE_PATH})
-set (LIBCOMPIZCONFIG_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
-set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LIBCOMPIZCONFIGZ_CMAKE_MODULE_PATH})
-
 include (CompizCommon)
 include (CompizPackage)
 include (CheckLibraryExists)
 include (CheckIncludeFile)
 
+set (CMAKE_MODULE_PATH_ORIG ${CMAKE_MODULE_PATH})
+set (LIBCOMPIZCONFIG_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LIBCOMPIZCONFIG_CMAKE_MODULE_PATH})
+
 set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
 # libcompizconfig package version number
@@ -144,7 +141,6 @@
 
 add_subdirectory (config)
 add_subdirectory (backend)
-add_subdirectory (plugin)
 add_subdirectory (src)
 add_subdirectory (include)
 add_subdirectory (cmake)

=== modified file 'compizconfig/libcompizconfig/backend/src/ini.c'
--- compizconfig/libcompizconfig/backend/src/ini.c	2011-08-20 19:03:37 +0000
+++ compizconfig/libcompizconfig/backend/src/ini.c	2012-05-21 09:36:37 +0000
@@ -82,15 +82,19 @@
     configDir = getenv ("XDG_CONFIG_HOME");
     if (configDir && strlen (configDir))
     {
-	asprintf (&fileName, "%s/%s/%s.ini", configDir, SETTINGPATH, profile);
+	if (asprintf (&fileName, "%s/%s/%s.ini", configDir, SETTINGPATH, profile) == -1)
+	    return NULL;
+
 	return fileName;
     }
 
     configDir = getenv ("HOME");
     if (configDir && strlen (configDir))
     {
-	asprintf (&fileName, "%s/.config/%s/%s.ini", configDir, SETTINGPATH,
-		  profile);
+	if (asprintf (&fileName, "%s/.config/%s/%s.ini", configDir, SETTINGPATH,
+		      profile) == -1)
+	    return NULL;
+
 	return fileName;
     }
 
@@ -265,7 +269,8 @@
     if (!data)
 	return;
 
-    asprintf (&keyName, "s%d_%s", context->screenNum, setting->name);
+    if (asprintf (&keyName, "s%d_%s", context->screenNum, setting->name) == -1)
+	return;
 
     switch (setting->type)
     {
@@ -455,7 +460,8 @@
     if (!data)
 	return;
 
-    asprintf (&keyName, "s%d_%s", context->screenNum, setting->name);
+    if (asprintf (&keyName, "s%d_%s", context->screenNum, setting->name) == -1)
+	return;
 
     if (setting->isDefault)
     {
@@ -656,7 +662,8 @@
     configDir = getenv ("XDG_CONFIG_HOME");
     if (configDir && strlen (configDir))
     {
-	asprintf (&filePath, "%s/%s", configDir, SETTINGPATH);
+	if (asprintf (&filePath, "%s/%s", configDir, SETTINGPATH) == -1)
+	    return NULL;
 	
 	ret = scanConfigDir(filePath);
 	free(filePath);
@@ -669,7 +676,9 @@
     if (!homeDir)
 	return NULL;
 
-    asprintf (&filePath, "%s/.config/%s", homeDir, SETTINGPATH);
+    if (asprintf (&filePath, "%s/.config/%s", homeDir, SETTINGPATH) == -1)
+	filePath = NULL;
+
     if (!filePath)
 	return NULL;
 

=== removed directory 'compizconfig/libcompizconfig/plugin'
=== removed file 'compizconfig/libcompizconfig/plugin/CMakeLists.txt'
--- compizconfig/libcompizconfig/plugin/CMakeLists.txt	2010-05-10 07:42:31 +0000
+++ compizconfig/libcompizconfig/plugin/CMakeLists.txt	1970-01-01 00:00:00 +0000
@@ -1,6 +0,0 @@
-find_package (Compiz REQUIRED)
-
-include (CompizCommon)
-include (CompizPackage)
-
-compiz_add_plugins_in_folder (${CMAKE_CURRENT_SOURCE_DIR})

=== removed file 'compizconfig/libcompizconfig/plugin/ccp.xml'
--- compizconfig/libcompizconfig/plugin/ccp.xml	2010-04-22 04:12:52 +0000
+++ compizconfig/libcompizconfig/plugin/ccp.xml	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<compiz>
-	<plugin name="ccp">
-		<_short>CCP</_short>
-		<_long>Compizconfig Settings Plugins</_long>
-    </plugin>
-</compiz>

=== modified file 'compizconfig/libcompizconfig/src/CMakeLists.txt'
--- compizconfig/libcompizconfig/src/CMakeLists.txt	2012-05-16 19:35:03 +0000
+++ compizconfig/libcompizconfig/src/CMakeLists.txt	2012-05-21 09:36:37 +0000
@@ -1,5 +1,4 @@
 include_directories (
-    ${CMAKE_SOURCE_DIR}/include
     ${CMAKE_CURRENT_BINARY_DIR}
     ${CMAKE_CURRENT_SOURCE_DIR}
     ${LIBCOMPIZCONFIG_INCLUDE_DIRS}

=== modified file 'compizconfig/libcompizconfig/src/compiz.cpp'
--- compizconfig/libcompizconfig/src/compiz.cpp	2012-01-23 11:37:14 +0000
+++ compizconfig/libcompizconfig/src/compiz.cpp	2012-05-21 09:36:37 +0000
@@ -18,6 +18,8 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
+#include <limits>
+
 #ifdef USE_PROTOBUF
 #include "compizconfig.pb.h"
 #include <google/protobuf/io/zero_copy_stream_impl.h>
@@ -47,7 +49,7 @@
 
 #include <string>
 
-#include <core/core.h>
+
 
 namespace {
 
@@ -407,8 +409,8 @@
 initIntInfoPB (CCSSettingInfo * i, const OptionMetadata & option)
 {
     int num, j;
-    i->forInt.min = MINSHORT;
-    i->forInt.max = MAXSHORT;
+    i->forInt.min = std::numeric_limits <short>::min ();
+    i->forInt.max = std::numeric_limits <short>::max ();
     i->forInt.desc = NULL;
 
     if (option.has_int_min ())
@@ -448,8 +450,8 @@
 static void
 initFloatInfoPB (CCSSettingInfo * i, const OptionMetadata & option)
 {
-    i->forFloat.min = MINSHORT;
-    i->forFloat.max = MAXSHORT;
+    i->forFloat.min = std::numeric_limits <short>::min ();
+    i->forFloat.max = std::numeric_limits <short>::max ();
     i->forFloat.precision = 0.1f;
 
     if (option.has_float_min ())
@@ -879,7 +881,8 @@
     if (xmlFile)
     {
 	pPrivate->xmlFile = strdup (xmlFile);
-	asprintf (&pPrivate->xmlPath, "/compiz/plugin[@name = '%s']", name);
+	if (asprintf (&pPrivate->xmlPath, "/compiz/plugin[@name = '%s']", name) == -1)
+	    pPrivate->xmlPath = NULL;
     }
 
     plugin->context = context;
@@ -1585,8 +1588,8 @@
     char *name;
     char *value;
     int num, j;
-    i->forInt.min = MINSHORT;
-    i->forInt.max = MAXSHORT;
+    i->forInt.min = std::numeric_limits <short>::min ();
+    i->forInt.max = std::numeric_limits <short>::max ();
     i->forInt.desc = NULL;
 
     value = getStringFromXPath (node->doc, node, "min/child::text()");
@@ -1672,8 +1675,8 @@
     char *value;
     SetNumericLocale numeric_locale;
 
-    i->forFloat.min = MINSHORT;
-    i->forFloat.max = MAXSHORT;
+    i->forFloat.min = std::numeric_limits <short>::min ();
+    i->forFloat.max = std::numeric_limits <short>::max ();
     i->forFloat.precision = 0.1f;
 
     value = getStringFromXPath (node->doc, node, "min/child::text()");
@@ -1924,14 +1927,16 @@
 
     if (cacheHome && strlen (cacheHome))
     {
-	asprintf (&cacheBaseDir, "%s", cacheHome);
+	if (asprintf (&cacheBaseDir, "%s", cacheHome) == -1)
+	    cacheBaseDir = NULL;
     }
     else
     {
 	char *home = getenv ("HOME");
 	if (home && strlen (home))
 	{
-	    asprintf (&cacheBaseDir, "%s/.cache", home);
+	    if (asprintf (&cacheBaseDir, "%s/.cache", home) == -1)
+		cacheBaseDir = NULL;
 	}
     }
 
@@ -2514,7 +2519,9 @@
     if (file)
 	pPrivate->xmlFile = strdup (file);
 
-    asprintf (&pPrivate->xmlPath, "/compiz/plugin[@name = '%s']", name);
+    if (asprintf (&pPrivate->xmlPath, "/compiz/plugin[@name = '%s']", name) == -1)
+	pPrivate->xmlPath = NULL;
+
     plugin->context = context;
     plugin->name = strdup (name);
 
@@ -2753,7 +2760,9 @@
     char *xmlFilePath = NULL;
     void *pluginInfoPBv = NULL;
 
-    asprintf (&xmlFilePath, "%s/%s", xmlDirPath, xmlName);
+    if (asprintf (&xmlFilePath, "%s/%s", xmlDirPath, xmlName) == -1)
+	xmlFilePath = NULL;
+
     if (!xmlFilePath)
     {
 	fprintf (stderr, "[ERROR]: Can't allocate memory\n");
@@ -2789,7 +2798,9 @@
 	if (createProtoBufCacheDir () &&
 	    metadataCacheDir.length () > 0)
 	{
-	    asprintf (&pbFilePath, "%s/%s.pb", metadataCacheDir.c_str (), name);
+	    if (asprintf (&pbFilePath, "%s/%s.pb", metadataCacheDir.c_str (), name) == -1)
+		pbFilePath = NULL;
+
 	    if (!pbFilePath)
 	    {
 		fprintf (stderr, "[ERROR]: Can't allocate memory\n");
@@ -2989,14 +3000,17 @@
 
     char *xmlDirPath = NULL;
     char *xmlName = NULL;
-    asprintf (&xmlName, "%s.xml", name);
+    if (asprintf (&xmlName, "%s.xml", name) == -1)
+	xmlName = NULL;
 
     if (xmlName)
     {
 	char *home = getenv ("HOME");
 	if (home && strlen (home))
 	{
-	    asprintf (&xmlDirPath, "%s/.compiz-1/metadata", home);
+	    if (asprintf (&xmlDirPath, "%s/.compiz-1/metadata", home) == -1)
+		xmlDirPath = NULL;
+
 	    if (xmlDirPath)
 	    {
 		loadPluginFromXMLFile (context, xmlName, xmlDirPath);
@@ -3024,7 +3038,9 @@
     if (home && strlen (home))
     {
 	char *homeplugins = NULL;
-	asprintf (&homeplugins, "%s/.compiz-1/metadata", home);
+	if (asprintf (&homeplugins, "%s/.compiz-1/metadata", home) == -1)
+	    homeplugins = NULL;
+
 	if (homeplugins)
 	{
 	    loadPluginsFromXMLFiles (context, homeplugins);
@@ -3036,7 +3052,9 @@
     if (home && strlen (home))
     {
 	char *homeplugins = NULL;
-	asprintf (&homeplugins, "%s/.compiz-1/plugins", home);
+	if (asprintf (&homeplugins, "%s/.compiz-1/plugins", home) == -1)
+	    homeplugins = NULL;
+
 	if (homeplugins)
 	{
 	    loadPluginsFromName (context, homeplugins);

=== modified file 'compizconfig/libcompizconfig/src/config.c'
--- compizconfig/libcompizconfig/src/config.c	2010-05-22 03:57:23 +0000
+++ compizconfig/libcompizconfig/src/config.c	2012-05-21 09:36:37 +0000
@@ -38,14 +38,18 @@
     configDir = getenv ("XDG_CONFIG_HOME");
     if (configDir && strlen (configDir))
     {
-	asprintf (&fileName, "%s/%s/config", configDir, SETTINGPATH);
+	if (asprintf (&fileName, "%s/%s/config", configDir, SETTINGPATH) == -1)
+	    fileName = NULL;
+
 	return fileName;
     }
 
     configDir = getenv ("HOME");
     if (configDir && strlen (configDir))
     {
-	asprintf (&fileName, "%s/.config/%s/config", configDir, SETTINGPATH);
+	if (asprintf (&fileName, "%s/.config/%s/config", configDir, SETTINGPATH) == -1)
+	    fileName = NULL;
+
 	return fileName;
     }
 
@@ -61,7 +65,9 @@
     profile = getenv ("COMPIZ_CONFIG_PROFILE");
     if (profile && strlen (profile))
     {
-	asprintf (&section, "general_%s", profile);
+	if (asprintf (&section, "general_%s", profile) == -1)
+	    section = NULL;
+
 	return section;
     }
 

=== modified file 'compizconfig/libcompizconfig/src/ini.c'
--- compizconfig/libcompizconfig/src/ini.c	2011-08-20 19:03:37 +0000
+++ compizconfig/libcompizconfig/src/ini.c	2012-05-21 09:36:37 +0000
@@ -110,7 +110,8 @@
     char *sectionName;
     char *retValue;
 
-    asprintf (&sectionName, "%s:%s", section, entry);
+    if (asprintf (&sectionName, "%s:%s", section, entry) == -1)
+	return NULL;
 
     retValue = iniparser_getstring (dictionary, sectionName, NULL);
     free (sectionName);
@@ -126,7 +127,8 @@
 {
     char *sectionName;
 
-    asprintf (&sectionName, "%s:%s", section, entry);
+    if (asprintf (&sectionName, "%s:%s", section, entry) == -1)
+	return;
 
     if (!iniparser_find_entry (dictionary, (char*) section))
 	iniparser_add_entry (dictionary, (char*) section, NULL, NULL);
@@ -605,7 +607,9 @@
 {
     char *string = NULL;
 
-    asprintf (&string, "%i", value);
+    if (asprintf (&string, "%i", value) == -1)
+	string = NULL;
+
     if (string)
     {
 	setIniString (dictionary, section, entry, string);
@@ -621,7 +625,9 @@
 {
     char *string = NULL;
 
-    asprintf (&string, "%f", value);
+    if (asprintf (&string, "%f", value) == -1)
+	string = NULL;
+
     if (string)
     {
 	setIniString (dictionary, section, entry, string);
@@ -815,7 +821,9 @@
 {
     char *sectionName;
 
-    asprintf (&sectionName, "%s:%s", section, entry);
+    if (asprintf (&sectionName, "%s:%s", section, entry) == -1)
+	return;
+
     iniparser_unset (dictionary, sectionName);
     free (sectionName);
 }

=== modified file 'compizconfig/libcompizconfig/src/main.c'
--- compizconfig/libcompizconfig/src/main.c	2011-11-10 00:58:18 +0000
+++ compizconfig/libcompizconfig/src/main.c	2012-05-21 09:36:37 +0000
@@ -602,8 +602,10 @@
 
     if (home && strlen (home))
     {
-	asprintf (&dlname, "%s/.compizconfig/backends/lib%s.so", 
-		  home, backend);
+	if (asprintf (&dlname, "%s/.compizconfig/backends/lib%s.so",
+		      home, backend) == -1)
+	    dlname = NULL;
+
 	dlerror ();
 	dlhand = dlopen (dlname, RTLD_NOW | RTLD_NODELETE | RTLD_LOCAL);
 	err = dlerror ();
@@ -614,8 +616,9 @@
         if (dlname) {
 	        free (dlname);
         }
-	asprintf (&dlname, "%s/compizconfig/backends/lib%s.so", 
-		  LIBDIR, backend);
+	if (asprintf (&dlname, "%s/compizconfig/backends/lib%s.so",
+		      LIBDIR, backend) == -1)
+	    dlname = NULL;
 	dlhand = dlopen (dlname, RTLD_NOW | RTLD_NODELETE | RTLD_LOCAL);
 	err = dlerror ();
     }
@@ -2696,15 +2699,24 @@
 
     if (home && strlen (home))
     {
-	asprintf (&backenddir, "%s/.compizconfig/backends", home);
+	if (asprintf (&backenddir, "%s/.compizconfig/backends", home) == -1)
+	    backenddir = NULL;
+
+	if (backenddir)
+	{
+	    getBackendInfoFromDir (&rv, backenddir);
+	    free (backenddir);
+	}
+    }
+
+    if (asprintf (&backenddir, "%s/compizconfig/backends", LIBDIR) == -1)
+	backenddir = NULL;
+
+    if (backenddir)
+    {
 	getBackendInfoFromDir (&rv, backenddir);
 	free (backenddir);
     }
-
-    asprintf (&backenddir, "%s/compizconfig/backends", LIBDIR);
-
-    getBackendInfoFromDir (&rv, backenddir);
-    free (backenddir);
     return rv;
 }
 
@@ -2739,8 +2751,9 @@
 	    if (skipDefaults && setting->isDefault)
 		continue;
 
-	    asprintf (&keyName, "s%d_%s", 
-		      context->screenNum, setting->name);
+	    if (asprintf (&keyName, "s%d_%s",
+			  context->screenNum, setting->name) == -1)
+		return FALSE;
 
 	    switch (setting->type)
 	    {
@@ -2819,7 +2832,9 @@
     char         *sectionName = strdup (setting->parent->name);
     char         *iniValue = NULL;
 
-    asprintf (&keyName, "+s%d_%s", context->screenNum, setting->name);
+    if (asprintf (&keyName, "+s%d_%s", context->screenNum, setting->name) == -1)
+	return FALSE;
+
     if (ccsIniGetString (dict, sectionName, keyName, &iniValue))
     {
 	CCSSetting *newSetting = malloc (sizeof (CCSSetting));
@@ -2971,7 +2986,9 @@
     char         *sectionName = strdup (setting->parent->name);
     char         *iniValue = NULL;
 
-    asprintf (&keyName, "-s%d_%s", context->screenNum, setting->name);
+    if (asprintf (&keyName, "-s%d_%s", context->screenNum, setting->name) == -1)
+	return FALSE;
+
     if (ccsIniGetString (dict, sectionName, keyName, &iniValue))
     {
 	CCSSetting *newSetting = malloc (sizeof (CCSSetting));
@@ -3438,7 +3455,8 @@
     if (!home)
 	return FALSE;
 
-    asprintf (&dupath, "%s/.config/compiz-1/compizconfig/done_upgrades", home);
+    if (asprintf (&dupath, "%s/.config/compiz-1/compizconfig/done_upgrades", home) == -1)
+	return FALSE;
 
     completedUpgrades = fopen (dupath, "a+");
 
@@ -3539,8 +3557,9 @@
 	    if (!setting->isDefault && !overwriteNonDefault)
 		continue;
 
-	    asprintf (&keyName, "s%d_%s", 
-		      context->screenNum, setting->name);
+	    if (asprintf (&keyName, "s%d_%s",
+			  context->screenNum, setting->name) == -1)
+		return FALSE;
 
 	    switch (setting->type)
 	    {

=== renamed directory 'compizconfig/libcompizconfig/plugin/ccp' => 'plugins/ccp'
=== modified file 'plugins/ccp/CMakeLists.txt'
--- compizconfig/libcompizconfig/plugin/ccp/CMakeLists.txt	2010-05-17 18:21:50 +0000
+++ plugins/ccp/CMakeLists.txt	2012-05-21 09:36:37 +0000
@@ -1,12 +1,6 @@
 find_package (Compiz REQUIRED)
 
-include (CompizPlugin)
-include (CompizCommon)
-
-set (COMPIZ_PLUGIN_INSTALL_TYPE
-     "compiz")
-
-compiz_plugin (ccp LIBRARIES compizconfig)
+compiz_plugin (ccp LIBRARIES compizconfig CFLAGSADD -I${CMAKE_SOURCE_DIR}/compizconfig/libcompizconfig/include)
 
 if (COMPIZ_BUILD_WITH_RPATH)
     set_target_properties (

=== modified file 'plugins/ccp/src/ccp.h'
--- compizconfig/libcompizconfig/plugin/ccp/src/ccp.h	2010-05-10 07:42:31 +0000
+++ plugins/ccp/src/ccp.h	2012-05-21 09:36:37 +0000
@@ -18,10 +18,6 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
-#ifdef HAVE_CONFIG_H
-#  include "../config.h"
-#endif
-
 extern "C" {
 #include <string.h>
 #include <stdio.h>

